package com.zt.plat.module.qms.business.config.dal.mapper;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.module.qms.business.bus.dal.dataobject.BusinessAssayProjectDataDO;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectPageReqVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectDO;
import com.zt.plat.module.qms.business.dic.dal.dataobject.DictionaryProjectDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;

/**
 * 检测方法分析项目配置 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface ConfigAssayMethodProjectMapper extends BaseMapperX<ConfigAssayMethodProjectDO> {

    default PageResult<ConfigAssayMethodProjectDO> selectPage(ConfigAssayMethodProjectPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ConfigAssayMethodProjectDO>()
                .eqIfPresent(ConfigAssayMethodProjectDO::getConfigAssayMethodId, reqVO.getConfigAssayMethodId())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDictionaryProjectId, reqVO.getDictionaryProjectId())
                .eqIfPresent(ConfigAssayMethodProjectDO::getUnitId, reqVO.getUnitId())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDictionaryProjectUnit, reqVO.getDictionaryProjectUnit())
                .eqIfPresent(ConfigAssayMethodProjectDO::getIsNull, reqVO.getIsNull())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDataType, reqVO.getDataType())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(ConfigAssayMethodProjectDO::getFormula, reqVO.getFormula())
                .eqIfPresent(ConfigAssayMethodProjectDO::getAssessmentAccuracy, reqVO.getAssessmentAccuracy())
                .eqIfPresent(ConfigAssayMethodProjectDO::getIsDefaultEnabled, reqVO.getIsDefaultEnabled())
                .eqIfPresent(ConfigAssayMethodProjectDO::getSortNo, reqVO.getSortNo())
                .eqIfPresent(ConfigAssayMethodProjectDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(ConfigAssayMethodProjectDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(ConfigAssayMethodProjectDO::getRemark, reqVO.getRemark())
                .eqIfPresent(ConfigAssayMethodProjectDO::getVersion, reqVO.getVersion())
                .orderByDesc(ConfigAssayMethodProjectDO::getId));
    }

	default List<ConfigAssayMethodProjectExtendRespVO> selectByConfigAssayMethodId(Long configAssayMethodId) {
		return selectJoinList(ConfigAssayMethodProjectExtendRespVO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectDO>()
				.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, ConfigAssayMethodProjectDO::getDictionaryProjectId)
				.selectAll(ConfigAssayMethodProjectDO.class)
				.selectAs(DictionaryProjectDO::getKey, ConfigAssayMethodProjectExtendRespVO::getDictionaryProjectKey)
				.selectAs(DictionaryProjectDO::getSimpleName, ConfigAssayMethodProjectExtendRespVO::getSimpleName)
				.selectAs(DictionaryProjectDO::getShowName, ConfigAssayMethodProjectExtendRespVO::getShowName)
				.eq(ConfigAssayMethodProjectDO::getConfigAssayMethodId, configAssayMethodId));
	}

}